#!/bin/sh

gcat=/etc/xml/catalog
tcat=/etc/xml/docbook2x.xml

if test -f ${tcat}
then
  xmlcatalog --noout --del "-//Steve Cheng//DTD Man-XML V0.8.6//EN" ${tcat}
  xmlcatalog --noout --del "-//Steve Cheng//DTD Texi-XML V0.8.6//EN" ${tcat}
  xmlcatalog --noout --del "http://docbook2x.sourceforge.net/latest/dtd/" ${tcat}
  xmlcatalog --noout --del "http://docbook2x.sf.net/latest/dtd/" ${tcat}

  xmlcatalog --noout --del "-//Steve Cheng//DOCUMENT DocBook Texinfo Stylesheet//EN" ${tcat}
  xmlcatalog --noout --del "-//Steve Cheng//DOCUMENT DocBook Man-page Stylesheet//EN" ${tcat}
  xmlcatalog --noout --del "http://docbook2x.sourceforge.net/latest/xslt/" ${tcat}
  xmlcatalog --noout --del "http://docbook2x.sf.net/latest/xslt/" ${tcat}

  if test $(cat ${tcat} | wc -l) -eq $(xmlcatalog --create | wc -l)
  then
    rm ${tcat}
  fi
fi

en=$(echo -en "\n\b")

pids=\
"-//Steve Cheng//DTD"$en\
"-//Steve Cheng//DOCUMENT DocBook"$en\

uris=\
"http://docbook2x.sourceforge.net/latest/"$en\
"http://docbook2x.sf.net/latest/"$en\

if test -f ${gcat}
then
  normal_IFS=$IFS
  IFS=$en
  for pid in $pids $uris
  do
    IFS=$normal_IFS
    remove_catalog=0
    if test ! -f ${tcat}
    then
      remove_catalog=1
    else
      if test $(cat ${tcat} | grep --regexp=\""${pid}.*"\" | wc -l) == 0
      then
        remove_catalog=1
      fi
    fi
    if test $remove_catalog == 1
    then
      echo "Removing reference \"$pid\" to catalog ${tcat}"
      xmlcatalog --noout --del "$pid" ${gcat}
    fi
    IFS=$en
  done
  IFS=$normal_IFS
  if test $(cat ${gcat} | wc -l) -eq $(xmlcatalog --create | wc -l)
  then
    rm ${gcat}
  fi
fi
