#! /bin/bash

name=perl_vendor
badname=perl_vendor
ver=5.20.1
ver1=5
ver2=5.20
rev=1
shortver=$(echo "${ver}${rev}" | sed 's/-.*//')
libperl="msys-perl${ver2/./_}.dll"
subsys=msys2
srcname=${name}-${ver}
prefix=/usr
CFLAGS="-g -O2"
docdir=share/doc/${badname}/${ver}
SOURCE_ARCHIVE_FORMAT=.tar.bz2
SOURCE_ARCHIVE=${name}-${ver}${SOURCE_ARCHIVE_FORMAT}
preconf_patches=
docfiles="
README \
Changes*
INSTALL"
licfiles="Artistic Copying"
rebasebase=0x58000000

#if test "x${install_dirs}" == "x"; then install_dirs="--datarootdir=\${prefix}/share --docdir=\${prefix}/\${docdir} --sbindir=\${prefix}/sbin --libexecdir=\${prefix}/libexec --sysconfdir=/etc --localstatedir=/var"; fi
if test "x${install_dirs}" == "x"; then install_dirs="--datadir=\${prefix}/share --infodir=\${prefix}/share/info --mandir=\${prefix}/share/man --sbindir=\${prefix}/sbin --libexecdir=\${prefix}/libexec --sysconfdir=\${prefix}/etc --localstatedir=/var"; fi


reposrc=""

declare -a archives

i=0
archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Pod-Escapes/Pod-Escapes-1.04.tar.gz/00ea2e0d2e84ed98517a4616708b68d3/Pod-Escapes-1.04.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Pod-Simple/Pod-Simple-3.28.tar.gz/ee65094e29924948ae02fe33229cc5e4/Pod-Simple-3.28.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Test-Pod/Test-Pod-1.48.tar.gz/c6bfd00ccdcb417d68fb3c0a0ec884c8/Test-Pod-1.48.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Devel-Symdump/Devel-Symdump-2.14.tar.gz/2d28b91792d0ef6bae2f75c4a635edee/Devel-Symdump-2.14.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Pod-Coverage/Pod-Coverage-0.23.tar.gz/12229e553ee7887680ee3db11da5ee52/Pod-Coverage-0.23.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Test-Pod-Coverage/Test-Pod-Coverage-1.10.tar.gz/c9ea5f4182415b13d2db18484a38c01b/Test-Pod-Coverage-1.10.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Compress-Bzip2/Compress-Bzip2-2.19.tar.gz/dd4ebb4e88a50cc9a85e282618fdf88f/Compress-Bzip2-2.19.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-IO-String/IO-String-1.08.tar.gz/250e5424f290299fc3d6b5d1e9da3835/IO-String-1.08.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Archive-Zip/Archive-Zip-1.39.tar.gz/851316e59625317a89e40418a26c676c/Archive-Zip-1.39.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-TermReadKey/TermReadKey-2.32.tar.gz/c55420c3456b8e470a01d6557b1045a8/TermReadKey-2.32.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Term-ReadLine-Perl/Term-ReadLine-Perl-1.0303.tar.gz/a77ecf4921cc714820fef898c6cb0eaf/Term-ReadLine-Perl-1.0303.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Term-ReadLine-Gnu/Term-ReadLine-Gnu-1.25.tar.gz/ac4edfd7c5604be0343a124660f1d44e/Term-ReadLine-Gnu-1.25.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-XML-NamespaceSupport/XML-NamespaceSupport-1.11.tar.gz/222cca76161cd956d724286d36b607da/XML-NamespaceSupport-1.11.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-XML-SAX-Base/XML-SAX-Base-1.08.tar.gz/38c8c3247dfd080712596118d70dbe32/XML-SAX-Base-1.08.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-XML-SAX/XML-SAX-0.99.tar.gz/290f5375ae87fdebfdb5bc3854019f24/XML-SAX-0.99.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-XML-LibXML/XML-LibXML-2.0117.tar.gz/484308164ecab1d7d0eddf4dc4c9c0ca/XML-LibXML-2.0117.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-XML-Parser/XML-Parser-2.43.tar.gz/2c9ca46832d8e7578bcda99eba3a47f1/XML-Parser-2.43.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Proc-ProcessTable/Proc-ProcessTable-0.50.tar.gz/3b21edabad48989c44d784f2059f3837/Proc-ProcessTable-0.50.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-YAML/YAML-1.13.tar.gz/3bda8716c873050c8238f45c276b6c37/YAML-1.13.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Config-Tiny/Config-Tiny-2.20.tgz/d239ea56157fcd61ac796fc13d585dc3/Config-Tiny-2.20.tgz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-File-Copy-Recursive/File-Copy-Recursive-0.38.tar.gz/e76dc75ab456510d67c6c3a95183f72f/File-Copy-Recursive-0.38.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-IPC-Run3/IPC-Run3-0.048.tar.gz/5a8cec571c51a118b265cf6e24e55761/IPC-Run3-0.048.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Probe-Perl/Probe-Perl-0.03.tar.gz/8876e1b99c531800a86b383702e0ab73/Probe-Perl-0.03.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://ftp.tw.freebsd.org/pub/FreeBSD/ports/distfiles/Tee-0.14.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-IO-CaptureOutput/IO-CaptureOutput-1.1102.tar.gz/367b3c0eb33a4b600de4009b0445ae0d/IO-CaptureOutput-1.1102.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-File-pushd/File-pushd-1.009.tar.gz/a6a6226d70e90883ae9fdad69227279c/File-pushd-1.009.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-File-Which/File-Which-1.09.tar.gz/b9429edaad7f45caafa4d458afcfd8af/File-Which-1.09.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-File-HomeDir/File-HomeDir-1.00.tar.gz/aa290cab9db52e2f76280fd1febf794e/File-HomeDir-1.00.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Digest-SHA/Digest-SHA-5.93.tar.gz/d3cc8a7af2b04d3d10f4202874cc6659/Digest-SHA-5.93.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-IPC-Run/IPC-Run-0.94.tar.gz/c963902894d3796b16624b3b4aea94b4/IPC-Run-0.94.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Module-Signature/Module-Signature-0.73.tar.gz/de27bbca948ba8a13a7f614414cb623d/Module-Signature-0.73.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-URI/URI-1.65.tar.gz/12c5d612a20ddd42041a5aa426f66269/URI-1.65.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-HTML-Tagset/HTML-Tagset-3.20.tar.gz/d2bfa18fe1904df7f683e96611e87437/HTML-Tagset-3.20.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-HTML-Parser/HTML-Parser-3.71.tar.gz/9128a45893097dfa3bf03301b19c5efe/HTML-Parser-3.71.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-HTTP-Date/HTTP-Date-6.02.tar.gz/52b7a0d5982d61be1edb217751d7daba/HTTP-Date-6.02.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Encode-Locale/Encode-Locale-1.03.tar.gz/de8422d068634e7c1068dab4e18b452f/Encode-Locale-1.03.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-LWP-MediaTypes/LWP-MediaTypes-6.02.tar.gz/8c5f25fb64b974d22aff424476ba13c9/LWP-MediaTypes-6.02.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-HTTP-Message/HTTP-Message-6.06.tar.gz/e563ac516e28d33f65bc0f295f625f85/HTTP-Message-6.06.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-File-Listing/File-Listing-6.04.tar.gz/83f636b477741f3a014585bb9cc079a6/File-Listing-6.04.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-HTTP-Daemon/HTTP-Daemon-6.01.tar.gz/ed0ae02d25d7f1e89456d4d69732adc2/HTTP-Daemon-6.01.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-WWW-RobotRules/WWW-RobotRules-6.02.tar.gz/b7186e8b8b3701e70c22abf430742403/WWW-RobotRules-6.02.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-HTTP-Negotiate/HTTP-Negotiate-6.01.tar.gz/1236195250e264d7436e7bb02031671b/HTTP-Negotiate-6.01.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-HTTP-Cookies/HTTP-Cookies-6.01.tar.gz/ecfd0eeb88512033352c2f13c9580f03/HTTP-Cookies-6.01.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Net-HTTP/Net-HTTP-6.07.tar.gz/b6da691523456089d7a812ac398bc77e/Net-HTTP-6.07.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-libwww-perl/libwww-perl-6.08.tar.gz/28e5005609af16c1fa297d12e0312f86/libwww-perl-6.08.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Net-IP/Net-IP-1.26.tar.gz/3a98e3ac45d69ea38a63a7e678bd716d/Net-IP-1.26.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Digest-HMAC/Digest-HMAC-1.03.tar.gz/e6a5d6f552da16eacb5157ea4369ff9d/Digest-HMAC-1.03.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Net-DNS/Net-DNS-0.81.tar.gz/26375d4310beb108b0e2b3bf30403ee5/Net-DNS-0.81.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Test-Reporter/Test-Reporter-1.60.tar.gz/e36fc3c25a71b2ceba2ae21c6a2e02fc/Test-Reporter-1.60.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Path-Class/Path-Class-0.35.tar.gz/575b60a5c5e22e259c1df62a59fdfe85/Path-Class-0.35.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Try-Tiny/Try-Tiny-0.22.tar.gz/6769658bfbca241a470206c9a8819ff2/Try-Tiny-0.22.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Crypt-SSLeay/Crypt-SSLeay-0.72.tar.gz/77d955c9056dbb12413d95d8852a9cdf/Crypt-SSLeay-0.72.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-common-sense/common-sense-3.73.tar.gz/6da7455a43ab60ed21c2a5e3b3ddeda8/common-sense-3.73.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-JSON-XS/JSON-XS-3.01.tar.gz/b7be65295baf6dd9233c6494782c1153/JSON-XS-3.01.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-JSON/JSON-2.90.tar.gz/e1512169a623e790a3f69b599cc1d3b9/JSON-2.90.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://search.cpan.org/CPAN/authors/id/D/DA/DAGOLDEN/Metabase-Client-Simple-0.009.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Sub-Install/Sub-Install-0.928.tar.gz/e1ce4f9cb6b2f6b8778b036c31afa5ab/Sub-Install-0.928.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Data-UUID/Data-UUID-1.220.tar.gz/3db849cb2ebedd969cb0090d91e39712/Data-UUID-1.220.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Params-Util/Params-Util-1.07.tar.gz/02db120c0eef87aae1830cc62bdec37b/Params-Util-1.07.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Data-OptList/Data-OptList-0.109.tar.gz/de3f747d6b802ded363cf434a96dab8f/Data-OptList-0.109.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Sub-Exporter/Sub-Exporter-0.987.tar.gz/5332d269a7ba387773fcd140b72a0ed2/Sub-Exporter-0.987.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Data-GUID/Data-GUID-0.048.tar.gz/8709af7609214edcad1ec99ecd62f048/Data-GUID-0.048.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-CPAN-DistnameInfo/CPAN-DistnameInfo-0.12.tar.gz/06bc803c0e4fb7735ddc7282163f1cc3/CPAN-DistnameInfo-0.12.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://backpan.perl.org/authors/id/D/DA/DAGOLDEN/Metabase-Fact-0.024.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Test-Tester/Test-Tester-0.109.tar.gz/d8fd872ee7e959f89a4af0371a7e782d/Test-Tester-0.109.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Test-NoWarnings/Test-NoWarnings-1.04.tar.gz/682ed043f7d3e38f3dfd8745fd21c49a/Test-NoWarnings-1.04.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://search.cpan.org/CPAN/authors/id/H/HM/HMBRAND/Config-Perl-V-0.22.tgz
i=$(( $i + 1 ))

archives[$i]=http://search.cpan.org/CPAN/authors/id/D/DA/DAGOLDEN/CPAN-Testers-Report-1.999002.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://search.cpan.org/CPAN/authors/id/D/DA/DAGOLDEN/Test-Reporter-Transport-Metabase-1.999008.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Capture-Tiny/Capture-Tiny-0.27.tar.gz/63ee233f1dfaa75c5233839407b87ae3/Capture-Tiny-0.27.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Devel-Autoflush/Devel-Autoflush-0.06.tar.gz/d5fc7d177e17067710caa2d2152e02a9/Devel-Autoflush-0.06.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-IPC-Cmd/IPC-Cmd-0.92.tar.gz/3efb414f6d5d6aecc5b32cd82541895d/IPC-Cmd-0.92.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://ftp.tw.freebsd.org/pub/FreeBSD/ports/distfiles/CPAN-Reporter-1.2011.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Module-ScanDeps/Module-ScanDeps-1.17.tar.gz/d8c87c2ca6c94d699b856e999fa0d247/Module-ScanDeps-1.17.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-PAR-Dist/PAR-Dist-0.49.tar.gz/bd852113974544f3c8c107ab4055cf8c/PAR-Dist-0.49.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Socket6/Socket6-0.25.tar.gz/e6c40d662b1fc5ffd436b7f50daa1f04/Socket6-0.25.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-IO-Socket-INET6/IO-Socket-INET6-2.72.tar.gz/510ddc1bd75a8340ca7226123fb545c1/IO-Socket-INET6-2.72.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://www.cpan.org/authors/id/R/RU/RURBAN/B-Generate-1.50.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-PadWalker/PadWalker-2.0.tar.gz/9d602cf26e3e9086865a57708b2a0db2/PadWalker-2.0.tar.gz
i=$(( $i + 1 ))

archives[$i]=http://pkgs.fedoraproject.org/repo/pkgs/perl-Data-Alias/Data-Alias-1.18.tar.gz/08154fc73e7b5da115cd8e7a72f262ae/Data-Alias-1.18.tar.gz
i=$(( $i + 1 ))

if test ! "$MSYSTEM" == "MSYS" -a "$subsys" == "msys2"
then
  echo "You must be in an MSYS shell to build a msys package"
  exit 4
fi

if test ! "$MSYSTEM" == "MINGW32" -a "$subsys" == "mingw32"
then
  echo "You must be in an MINGW shell to build a mingw32 package"
  exit 5
fi

pkgbuilddir=`pwd` || fail $LINENO
echo Acting from the directory ${pkgbuilddir}

patchfiles=`for i in ${pkgbuilddir}/patches/*.${subsys}.patch ${pkgbuilddir}/patches/*.all.patch; do if test $(expr index "$i" "*") -ge 1; then : ;else echo $i; fi; done | sort`
x=${pkgbuilddir}/${badname}
scriptfiles=`for i in $x-pre-install.sh $x-post-install.sh $x-pre-remove.sh $x-post-remove.sh; do if test ! -f $i; then : ;else echo $(basename $i); fi; done | sort`

instdir=${pkgbuilddir}/inst
blddir=${pkgbuilddir}/bld
logdir=${pkgbuilddir}/logs
srcdir=${pkgbuilddir}/${name}-${ver}

echo The source directory is ${srcdir}

srcdirname=$(basename ${srcdir})

capname=Unknown
if test "x${subsys}" == "xmingw32"
then
capname=MinGW
elif test "x${subsys}" == "xmsys2"
then
capname=MSYS
fi

_sysver=$(uname -r)
export SYSVER=${_sysver%%\(*}

if test "x$arch" == "x" -a ! "x$buildalias" == "x"
then
  arch_index=$(expr index $buildalias -)
  arch_up_to=$((arch_index - 1))
  arch=${buildalias::${arch_up_to}}
fi
if test "x$arch" == "x"
then
  echo "Can't determine architecture."
  echo "Set 'arch' or 'buildalias' environment variable."
  exit 1
fi
archname=${arch}-msys-threads-64int
archver=$shortver

p1=${prefix:1}

do_download=1
do_unpack=1
do_patch=0
do_preconfigure=0
do_reconfigure=0
do_configure=0
do_cpan=0
do_check=0
do_install=1
do_fixinstall=0
do_pack=1
do_clean=1

if test ! "x$reposrc" = "x"
then
  srcdir="$reposrc"
  do_download=0
  do_unpack=0
  do_reconfigure=1
fi

zeroall() {
      do_download=0
      do_unpack=0
      do_patch=0
      do_preconfigure=0
      do_reconfigure=0
      do_configure=0
      do_make=0
      do_check=0
      do_install=0
      do_fixinstall=0
      do_pack=0
      do_clean=0
}

while [ $# -gt 0 ]
do
  case $1 in
    --download) do_download=1 ; shift 1 ;;
    --unpack) do_unpack=1 ; shift 1 ;;
    --patch) do_patch=1 ; shift 1 ;;
    --preconfigure) do_preconfigure=1 ; shift 1 ;;
    --reconfigure) do_reconfigure=1 ; shift 1 ;;
    --configure) do_configure=1 ; shift 1 ;;
    --make) do_make=1 ; shift 1 ;;
    --check) do_check=1 ; shift 1 ;;
    --install) do_install=1 ; shift 1 ;;
    --fixinstall) do_fixinstall=1 ; shift 1 ;;
    --pack) do_pack=1 ; shift 1 ;;
    --download-only) zeroall; do_download=1 ; shift 1 ;;
    --unpack-only) zeroall; do_unpack=1 ; shift 1 ;;
    --patch-only) zeroall; do_patch=1 ; shift 1 ;;
    --preconfigure-only) zeroall; do_preconfigure=1 ; shift 1 ;;
    --reconfigure-only) zeroall; do_reconfigure=1 ; shift 1 ;;
    --configure-only) zeroall; do_configure=1 ; shift 1 ;;
    --make-only) zeroall; do_make=1 ; shift 1 ;;
    --check-only) zeroall; do_check=1 ; shift 1 ;;
    --install-only) zeroall; do_install=1 ; shift 1 ;;
    --fixinstall-only) zeroall; do_fixinstall=1 ; shift 1 ;;
    --pack-only) zeroall; do_pack=1 ; shift 1 ;;
    --dont-clean) do_clean=0 ; shift 1 ;;
    *) shift 1 ;;
  esac
done


fail() {
  echo "failure at line $1"
  exit 1
}

if test ! -d ${logdir}
then
  mkdir -p ${logdir} || fail $LINENO
fi

if test "x$do_download" == "x1"
then
  rm -f ${logdir}/download.log
  cd ${pkgbuilddir}/vendor/
  for i in ${!archives[*]}
  do
    SOURCE_ARCHIVE=$(basename ${archives[$i]})
    if test ! -f ${SOURCE_ARCHIVE}
    then
      echo "Downloading ${SOURCE_ARCHIVE} ..." 2>&1 | tee ${logdir}/download.log
      wget ${archives[$i]} 2>&1 | tee -a ${logdir}/download.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
    fi

    if test -f ${SOURCE_ARCHIVE}.sha512
    then
      echo "Verifying sha512 sum ..." | tee -a ${logdir}/download.log
      sha512sum -c ${SOURCE_ARCHIVE}.sha512 2>&1 | tee -a ${logdir}/download.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
    else
      echo "Calculating sha512 sum ..." | tee -a ${logdir}/download.log
      sha512sum ${SOURCE_ARCHIVE} >${SOURCE_ARCHIVE}.sha512 2>>${logdir}/download.log || fail $LINENO
    fi
  done
  echo "Done downloading"
fi

if test "x$do_unpack" == "x1"
then
  rm -f ${logdir}/unpack.log

  echo Cleaning up inst and build directories | tee -a ${logdir}/unpack.log
  rm -rf ${instdir} 2>&1 | tee -a ${logdir}/unpack.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi

  echo "Done unpacking"
fi

source ${pkgbuilddir}/vendor/modules

if test "x$do_cpan" == "x1"
then
  cd ${pkgbuilddir}/vendor
    for m in $modules; do
      if [ $m != YAML ]; then # is broken, endless EUMM cycle
        echo perl -MCPAN -e"get \"$m\""
        perl -MCPAN -e"get \"$m\""
      fi
    done
fi

if test "x$do_install" == "x1"
then
  rm -f ${logdir}/install.log
  cd ${pkgbuilddir}/vendor

  echo Installing into ${instdir} from `pwd` | tee ${logdir}/install.log

  instvdir=$instdir
  export PERL5LIB=${instdir}/usr/lib/perl5/vendor_perl/5.20.11

  # CPAN, libXML and more
  for i in $exts
  do
    test -n ${i} || fail $LINENO
    if [ -d ${i} ]; then
      echo rm -rf ${i} 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      rm -rf ${i} 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
    fi
    echo tar xvzf ${i}.tar.gz  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
    if [ ! -e ${i}.tar.gz -a ! -e ${i}.tgz ]; then echo "${i}.tar.gz and ${i}.tgz does not exist"  2>&1 | tee -a ${logdir}/install.log ; fail $LINENO ; fi
    if [ -e ${i}.tar.gz ]; then aname=${i}.tar.gz; else aname=${i}.tgz; fi
    tar xvzf ${aname}  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
    if [ ! -d ${i} ]; then echo "${i} not created. Aborted"  2>&1 | tee -a ${logdir}/install.log ; fail $LINENO ; fi
    echo cd ${i}  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi

    cd ${i}

    if test -f ../$i.patch; then
      echo "${i}: patch -b -f -p1 ../$i.patch"  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      patch -b -f -p1 < ../$i.patch  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      find -name \*.orig -exec chmod 0444 \{\} \;  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
    fi
    if [ -f Makefile.PL ]; then
      if test ! -e Makefile.PL
      then
        chmod +x Makefile.PL
      fi
      echo "${i}: perl Makefile.PL"  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      opts=
      if [ ${i#Crypt-SSLeay} != $i ]; then opts="-libpath=/usr"; fi
      perl Makefile.PL $opts  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      echo "${i}: make" 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      make -j1  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      if [ $? -gt 0 ]; then
        echo "make exitcode $?. Aborted" 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
        fail $LINENO
      fi
      #XXX Some not to vendor. Most do it automatically
      if [ ${i#ExtUtils-ParseXS} != $i -o ${i#ExtUtils-CBuilder}  != $i ]; then
        echo "${i}: make install DESTDIR=${instvdir}"  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
        make -j1 install DESTDIR=${instvdir}  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      else
        echo "${i}: make install_vendor DESTDIR=${instvdir}"  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
        make -j1 install_vendor DESTDIR=${instvdir}  2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      fi
    else
      if test ! -e Build.PL
      then
        chmod +x Build.PL
      fi
      echo "${i}: perl Build.PL --destdir=${instvdir} --installdirs=vendor" 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      perl Build.PL --destdir=${instvdir} --installdirs=vendor 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      echo "${i}: Build" 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      ./Build 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      echo "${i}: Build install" 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
      ./Build install 2>&1 | tee -a ${logdir}/install.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi
    fi
    cd ..
    rm -rf ./${i}
  done
  find ${instvdir} -name .packlist -exec sed -i -e"s,${instdir},," \{\} \;

  #for taint
  chmod -R g-w ${instvdir}${prefix}/lib/perl5/vendor_perl/

  /mingw/bin/split-debug.py $(cd ${instdir}; pwd -W) --target=$buildalias && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi





  if test ! "x${scriptfiles}" == "x"
  then
    mkdir -p ${instdir}/var/lib/mingw-get/scripts
  fi
  for scriptfile in ${scriptfiles}
  do
    if test ! "x${scriptfile}" == "x"
    then
      cp ${scriptfile} ${instdir}/var/lib/mingw-get/scripts/$(echo $(basename ${scriptfile}) | sed -e 's/'${badname}'-/'${badname}'-'${ver}'-'${rev}'-/')
    fi
  done
fi

if test "x$do_pack" == "x1"
then
  rm -f ${logdir}/pack.log
  packed=${pkgbuilddir}/packed
  installed=${pkgbuilddir}/installed
  unused=${pkgbuilddir}/unused
  rm -f ${packed}
  cd ${instdir}
  echo Packing | tee -a ${logdir}/pack.log

  pkgtmp=${ver}-${rev}-${subsys}_${arch}

  tar cv --xz -f ${pkgbuilddir}/${badname}-${pkgtmp}-bin.tar.xz \
--exclude=*.dbg \
$p1/bin \
$p1/lib \
  2>&1 | tee -a ${logdir}/pack.log | tee -a ${packed} && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi

  tar cv --xz -f ${pkgbuilddir}/${badname}-${pkgtmp}-dbg.tar.xz \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/B/Generate/Generate.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Compress/Bzip2/Bzip2.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Crypt/SSLeay/SSLeay.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Data/Alias/Alias.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Data/UUID/UUID.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Digest/SHA/SHA.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/HTML/Parser/Parser.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/JSON/XS/XS.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Net/DNS/DNS.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/PadWalker/PadWalker.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Proc/ProcessTable/ProcessTable.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Socket6/Socket6.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Term/ReadKey/ReadKey.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/Term/ReadLine/Gnu/Gnu.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/XML/LibXML/LibXML.dll.dbg \
$p1/lib/perl5/vendor_perl/${ver}*/${archname}/auto/XML/Parser/Expat/Expat.dll.dbg \
  2>&1 | tee -a ${logdir}/pack.log | tee -a ${packed} && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi

  tar cv --xz -f ${pkgbuilddir}/${badname}-${pkgtmp}-doc.tar.xz \
$p1/share/man \
 2>&1 | tee -a ${logdir}/pack.log | tee -a ${packed} && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi

  uniq <${packed} | sort  | while read p; do if test -f ${instdir}/$p -o -L ${instdir}/$p; then echo $p; fi; done >${packed}.files
  find ${instdir} ! -type d -printf '%P\n' | uniq | sort >${installed}
  diff -u0 ${installed} ${packed}.files | tail -n+3 | sed -e 's/^-\(.\+\)$/\1/' -e '/^@@ .\+ @@$/d' >${unused}
  if test x0 != x$(wc -l < ${unused}); then
    echo "Unused files:"
    cat ${unused}
    echo ""
  fi
  rm -f ${installed} ${packed} ${packed}.files ${unused}

  cd ${pkgbuilddir}

  BLD="\
pkgbuild.sh \
$(if test -d patches; then echo patches; fi) \
vendor \
"

  tar cv --xz -f ${pkgbuilddir}/${badname}-${pkgtmp}-bld.tar.xz --exclude=vendor/*.gz $BLD 2>&1 | tee -a ${logdir}/pack.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi

  tar cv --xz -f ${pkgbuilddir}/${badname}-${pkgtmp}-src.tar.xz $BLD 2>&1 | tee -a ${logdir}/pack.log && if ! test "x${PIPESTATUS[0]}" == "x0"; then fail $LINENO; fi

fi

if test "x$do_clean" == "x1"
then

cd ${pkgbuilddir}
  rm -rf ${blddir} ${instdir}
  if test -d "${srcdir}" -a ! "x${srcdir}" == "x/" -a ! "x${srcdir}" == "x" -a ! "x${srcdir}" == "x${pkgbuilddir}"
  then
    rm -rf ${srcdir}
  fi
fi

echo "Done"
exit 0
